#include <stdio.h>
#include <propeller.h>

int fibo (int n)
{
    if (n < 2)
    {
        return (n);
    }
    else
    {
        return fibo(n - 1) + fibo(n - 2);
    }
}

extern unsigned int clock(void);

void main (int argc,  char* argv[])
{
    int n;
    int result;
    unsigned int startTime;
    unsigned int endTime;
    unsigned int executionTime;
    unsigned int rawTime;

    for (n = 0; n <= 26; n++)
    {
        printf("fibo(%02d) = ", n);
        startTime = CNT;
        result = fibo(n);
        endTime = CNT;
        rawTime = endTime - startTime;
        executionTime = rawTime / (CLKFREQ / 1000);
        printf ("%06d (%05ums) (%u ticks)\n", result, executionTime, rawTime);
    }
}
